# std::list< Type, Alloc > Class Template Reference
[Containers, Sequences]

A standard container with linear time access to elements, and fixed time insertion/deletion at any point in the sequence. More...

`#include <stl_list.h>`

Inheritance diagram for std::list< Type, Alloc >:

[legend]
List of all members.

## Public Member Functions

| list (const allocator_type &a=allocator_type())
| Default constructor creates no elements.
| list (size_type n, const value_type &value, const allocator_type &a=allocator_type())
| Create a list with copies of an exemplar element.
| list (size_type n)
| Create a list with default elements.
| list (const list &x)
| List copy constructor.
template<typename InputIterator> | list (InputIterator first, InputIterator last, const allocator_type &a=allocator_type())
| Builds a list from a range.
list & | operator= (const list &x)
| List assignment operator.
void | assign (size_type n, const value_type &__val)
| Assigns a given value to a list.
template<typename InputIterator> void | assign (InputIterator first, InputIterator last)
| Assigns a range to a list.
allocator_type | get_allocator () const
| Get a copy of the memory allocation object.
iterator | begin ()
const_iterator | begin () const
iterator | end ()
const_iterator | end () const
reverse_iterator | rbegin ()
const_reverse_iterator | rbegin () const
reverse_iterator | rend ()
const_reverse_iterator | rend () const
bool | empty () const
size_type | size () const
size_type | max_size () const
void | resize (size_type new_size, const value_type &x)
| Resizes the list to the specified number of elements.
void | resize (size_type new_size)
| Resizes the list to the specified number of elements.
reference | front ()
const_reference | front () const
reference | back ()
const_reference | back () const
void | push_front (const value_type &x)
| Add data to the front of the list.
void | pop_front ()
| Removes first element.
void | push_back (const value_type &x)
| Add data to the end of the list.
void | pop_back ()
| Removes last element.
iterator | insert (iterator position, const value_type &x)
| Inserts given value into list before specified iterator.
void | insert (iterator position, size_type n, const value_type &x)
| Inserts a number of copies of given data into the list.
template<typename InputIterator> void | insert (iterator position, InputIterator first, InputIterator last)
| Inserts a range into the list.
iterator | erase (iterator position)
| Remove element at given position.
iterator | erase (iterator first, iterator last)
| Remove a range of elements.
void | swap (list &x)
| Swaps data with another list.
void | clear ()
void | splice (iterator position, list &x)
| Insert contents of another list.
void | splice (iterator position, list &, iterator __i)
| Insert element from another list.
void | splice (iterator position, list &, iterator first, iterator last)
| Insert range from another list.
void | remove (const Type &value)
| Remove all elements equal to value.
template<typename Predicate> void | remove_if (Predicate)
| Remove all elements satisfying a predicate.
void | unique ()
| Remove consecutive duplicate elements.
template<typename BinaryPredicate> void | unique (BinaryPredicate)
| Remove consecutive elements satisfying a predicate.
void | merge (list &x)
| Merge sorted lists.
template<typename StrictWeakOrdering> void | merge (list &, StrictWeakOrdering)
| Merge sorted lists according to comparison function.
void | reverse ()
| Reverse the elements in list.
void | sort ()
| Sort the elements.
template<typename StrictWeakOrdering> void | sort (StrictWeakOrdering)
| Sort the elements according to comparison function.

## Detailed Description

### template<typename Type, typename Alloc = allocator<Type>>
class std::list< Type, Alloc >

A standard container with linear time access to elements, and fixed time insertion/deletion at any point in the sequence.

Meets the requirements of a container, a reversible container, and a sequence, including the optional sequence requirements with the exception of `at` and `operator`[].

This is a doubly linked list. Traversal up and down the list requires linear time, but adding and removing elements (or nodes) is done in constant time, regardless of where the change takes place. Unlike std::vector and std::deque, random-access iterators are not provided, so subscripting ( ``[] ) access is not allowed. For algorithms which only need sequential access, this lack makes no difference.

Also unlike the other standard containers, std::list provides specialized algorithms unique to linked lists, such as splicing, sorting, and in-place reversal.

Definition at line 389 of file stl_list.h.

## Constructor & Destructor Documentation

template<typename Type, typename Alloc = allocator<Type>>
std::list< Type, Alloc >::list | ( | const allocator_type & | a = `allocator_type()` | ) | `[inline, explicit]`

| Default constructor creates no elements. Definition at line 477 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
std::list< Type, Alloc >::list | ( | size_type | n,
|  | const value_type & | value,
|  | const allocator_type & | a = `allocator_type()`
| ) | `[inline]`

Create a list with copies of an exemplar element.

Parameters:

  | n | The number of elements to initially create.
  | value | An element to copy.

This constructor fills the list with n copies of value.

Definition at line 487 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
std::list< Type, Alloc >::list | ( | size_type | n | ) | `[inline, explicit]`

Create a list with default elements.

Parameters:

  | n | The number of elements to initially create.

This constructor fills the list with n copies of a default-constructed element.

Definition at line 500 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
std::list< Type, Alloc >::list | ( | const list< Type, Alloc > & | x | ) | `[inline]`

List copy constructor.

Parameters:

  | x | A list of identical element and allocator types.

The newly-created list uses a copy of the allocation object used by x.

Definition at line 511 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
template<typename InputIterator>
std::list< Type, Alloc >::list | ( | InputIterator | first,
|  | InputIterator | last,
|  | const allocator_type & | a = `allocator_type()`
| ) | `[inline]`

Builds a list from a range.

Parameters:

  | first | An input iterator.
  | last | An input iterator.

Create a list consisting of copies of the elements from [first,last). This is linear in N (where N is distance(first,last)).

Definition at line 530 of file stl_list.h.

## Member Function Documentation

template<typename Type, typename Alloc = allocator<Type>>
template<typename InputIterator>
void std::list< Type, Alloc >::assign | ( | InputIterator | first,
|  | InputIterator | last
| ) | `[inline]`

Assigns a range to a list.

Parameters:

  | first | An input iterator.
  | last | An input iterator.

This function fills a list with copies of the elements in the range [first,last).

Note that the assignment completely changes the list and that the resulting list's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 581 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
void std::list< Type, Alloc >::assign | ( | size_type | n,
|  | const value_type & | __val
| ) | `[inline]`

Assigns a given value to a list.

Parameters:

  | n | Number of elements to be assigned.
  | val | Value to be assigned.

This function fills a list with n copies of the given value. Note that the assignment completely changes the list and that the resulting list's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 564 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
const_reference std::list< Type, Alloc >::back | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reference to the data at the last element of the list. Definition at line 739 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
reference std::list< Type, Alloc >::back | ( |  | ) | `[inline]`

| Returns a read/write reference to the data at the last element of the list. Definition at line 731 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
const_iterator std::list< Type, Alloc >::begin | ( |  | ) | const`[inline]`

| Returns a read-only (constant) iterator that points to the first element in the list. Iteration is done in ordinary element order. Definition at line 608 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
iterator std::list< Type, Alloc >::begin | ( |  | ) | `[inline]`

Returns a read/write iterator that points to the first element in the list. Iteration is done in ordinary element order.

Definition at line 599 of file stl_list.h.

Referenced by std::list< Type, Allocator >::list(), std::list< Type, Alloc >::merge(), std::list< Type, Alloc >::operator=(), std::operator==(), std::list< Type, Alloc >::remove_if(), std::list< Type, Alloc >::resize(), std::list< Type, Alloc >::sort(), std::list< Type, Allocator >::splice(), and std::list< Type, Alloc >::unique().

template<typename Type, typename Alloc = allocator<Type>>
void std::list< Type, Alloc >::clear | ( |  | ) | `[inline]`

| Erases all the elements. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty. Definition at line 922 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
bool std::list< Type, Alloc >::empty | ( |  | ) | const`[inline]`

| Returns true if the list is empty. (Thus begin() would equal end().) Definition at line 670 of file stl_list.h. Referenced by std::list< Type, Alloc >::sort(), and std::list< Type, Allocator >::splice().

template<typename Type, typename Alloc = allocator<Type>>
const_iterator std::list< Type, Alloc >::end | ( |  | ) | const`[inline]`

| Returns a read-only (constant) iterator that points one past the last element in the list. Iteration is done in ordinary element order. Definition at line 625 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
iterator std::list< Type, Alloc >::end | ( |  | ) | `[inline]`

Returns a read/write iterator that points one past the last element in the list. Iteration is done in ordinary element order.

Definition at line 617 of file stl_list.h.

Referenced by std::list< Type, Allocator >::list(), std::list< Type, Alloc >::merge(), std::list< Type, Alloc >::operator=(), std::operator==(), std::list< Type, Alloc >::remove_if(), std::list< Type, Alloc >::resize(), std::list< Type, Allocator >::splice(), and std::list< Type, Alloc >::unique().

template<typename Type, typename Alloc = allocator<Type>>
iterator std::list< Type, Alloc >::erase | ( | iterator | first,
|  | iterator | last
| ) | `[inline]`

Remove a range of elements.

Parameters:

  | first | Iterator pointing to the first element to be erased.
  | last | Iterator pointing to one past the last element to be erased.

Returns:
  An iterator pointing to the element pointed to by last prior to erasing (or end()).

This function will erase the elements in the range [first,last) and shorten the list accordingly.

Due to the nature of a list this operation can be done in constant time, and only invalidates iterators/references to the element being removed. The user is also cautioned that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 895 of file stl_list.h.

template<typename Type, typename Alloc>
list< Type, Alloc >::iterator std::list< Type, Alloc >::erase | ( | iterator | position | ) |

Remove element at given position.

Parameters:

  | position | Iterator pointing to element to be erased.

Returns:
  An iterator pointing to the next element (or end()).

This function will erase the element at the given position and thus shorten the list by one.

Due to the nature of a list this operation can be done in constant time, and only invalidates iterators/references to the element being removed. The user is also cautioned that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 95 of file list.tcc.

Referenced by std::list< Type, Alloc >::operator=(), and std::list< Type, Alloc >::resize().

template<typename Type, typename Alloc = allocator<Type>>
const_reference std::list< Type, Alloc >::front | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reference to the data at the first element of the list. Definition at line 723 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
reference std::list< Type, Alloc >::front | ( |  | ) | `[inline]`

| Returns a read/write reference to the data at the first element of the list. Definition at line 715 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
allocator_type std::list< Type, Alloc >::get_allocator | ( |  | ) | const`[inline]`

| Get a copy of the memory allocation object. Definition at line 590 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
template<typename InputIterator>
void std::list< Type, Alloc >::insert | ( | iterator | position,
|  | InputIterator | first,
|  | InputIterator | last
| ) | `[inline]`

Inserts a range into the list.

Parameters:

  | position | An iterator into the list.
  | first | An input iterator.
  | last | An input iterator.

This function will insert copies of the data in the range [first,last) into the list before the location specified by position.

Due to the nature of a list this operation can be done in constant time, and does not invalidate iterators and references.

Definition at line 849 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
void std::list< Type, Alloc >::insert | ( | iterator | position,
|  | size_type | n,
|  | const value_type & | x
| ) | `[inline]`

Inserts a number of copies of given data into the list.

Parameters:

  | position | An iterator into the list.
  | n | Number of elements to be inserted.
  | x | Data to be inserted.

This function will insert a specified number of copies of the given data before the location specified by position.

Due to the nature of a list this operation can be done in constant time, and does not invalidate iterators and references.

Definition at line 830 of file stl_list.h.

template<typename Type, typename Alloc>
list< Type, Alloc >::iterator std::list< Type, Alloc >::insert | ( | iterator | position,
|  | const value_type & | x
| ) |

Inserts given value into list before specified iterator.

Parameters:

  | position | An iterator into the list.
  | x | Data to be inserted.

Returns:
  An iterator that points to the inserted data.

This function will insert a copy of the given value before the specified location. Due to the nature of a list this operation can be done in constant time, and does not invalidate iterators and references.

Definition at line 85 of file list.tcc.

Referenced by std::list< Type, Alloc >::operator=(), and std::list< Type, Alloc >::resize().

template<typename Type, typename Alloc = allocator<Type>>
size_type std::list< Type, Alloc >::max_size | ( |  | ) | const`[inline]`

| Returns the size() of the largest possible list. Definition at line 680 of file stl_list.h.

template<typename Type, typename Alloc>
template<typename StrictWeakOrdering>
void std::list< Type, Alloc >::merge | ( | list< Type, Alloc > & | ,
|  | StrictWeakOrdering |
| ) |

Merge sorted lists according to comparison function.

Parameters:

  | x | Sorted list to merge.
  | StrictWeakOrdering | Comparison function definining sort order.

Assumes that both x and this list are sorted according to StrictWeakOrdering. Merges elements of x into this list in sorted order, leaving x empty when complete. Elements in this list precede elements in x that are equivalent according to StrictWeakOrdering().

Definition at line 313 of file list.tcc.

References std::list< Type, Alloc >::begin(), and std::list< Type, Alloc >::end().

template<typename Type, typename Alloc>
void std::list< Type, Alloc >::merge | ( | list< Type, Alloc > & | x | ) |

Merge sorted lists.

Parameters:

  | x | Sorted list to merge.

Assumes that both x and this list are sorted according to operator<(). Merges elements of x into this list in sorted order, leaving x empty when complete. Elements in this list precede elements in x that are equal.

Definition at line 210 of file list.tcc.

References std::list< Type, Alloc >::begin(), and std::list< Type, Alloc >::end().

Referenced by std::list< Type, Alloc >::sort().

template<typename Type, typename Alloc>
list< Type, Alloc > & std::list< Type, Alloc >::operator= | ( | const list< Type, Alloc > & | x | ) |

List assignment operator.

Parameters:

  | x | A list of identical element and allocator types.

All the elements of x are copied, but unlike the copy constructor, the allocator object is not copied.

Definition at line 120 of file list.tcc.

References std::list< Type, Alloc >::begin(), std::list< Type, Alloc >::end(), std::list< Type, Alloc >::erase(), and std::list< Type, Alloc >::insert().

template<typename Type, typename Alloc = allocator<Type>>
void std::list< Type, Alloc >::pop_back | ( |  | ) | `[inline]`

| Removes last element. This is a typical stack operation. It shrinks the list by one. Due to the nature of a list this operation can be done in constant time, and only invalidates iterators/references to the element being removed. Note that no data is returned, and if the last element's data is needed, it should be retrieved before pop_back() is called. Definition at line 799 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
void std::list< Type, Alloc >::pop_front | ( |  | ) | `[inline]`

Removes first element.

This is a typical stack operation. It shrinks the list by one. Due to the nature of a list this operation can be done in constant time, and only invalidates iterators/references to the element being removed.

Note that no data is returned, and if the first element's data is needed, it should be retrieved before pop_front() is called.

Definition at line 770 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
void std::list< Type, Alloc >::push_back | ( | const value_type & | x | ) | `[inline]`

Add data to the end of the list.

Parameters:

  | x | Data to be added.

This is a typical stack operation. The function creates an element at the end of the list and assigns the given data to it. Due to the nature of a list this operation can be done in constant time, and does not invalidate iterators and references.

Definition at line 784 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
void std::list< Type, Alloc >::push_front | ( | const value_type & | x | ) | `[inline]`

Add data to the front of the list.

Parameters:

  | x | Data to be added.

This is a typical stack operation. The function creates an element at the front of the list and assigns the given data to it. Due to the nature of a list this operation can be done in constant time, and does not invalidate iterators and references.

Definition at line 754 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
const_reverse_iterator std::list< Type, Alloc >::rbegin | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reverse iterator that points to the last element in the list. Iteration is done in reverse element order. Definition at line 643 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
reverse_iterator std::list< Type, Alloc >::rbegin | ( |  | ) | `[inline]`

| Returns a read/write reverse iterator that points to the last element in the list. Iteration is done in reverse element order. Definition at line 634 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
void std::list< Type, Alloc >::remove | ( | const Type & | value | ) |

Remove all elements equal to value.

Parameters:

  | value | The value to remove.

Removes every element in the list equal to value. Remaining elements stay in list order. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

template<typename Type, typename Alloc>
template<typename Predicate>
void std::list< Type, Alloc >::remove_if | ( | Predicate |  | ) |

Remove all elements satisfying a predicate.

Parameters:

  | Predicate | Unary predicate function or object.

Removes every element in the list for which the predicate returns true. Remaining elements stay in list order. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 275 of file list.tcc.

References std::list< Type, Alloc >::begin(), and std::list< Type, Alloc >::end().

template<typename Type, typename Alloc = allocator<Type>>
const_reverse_iterator std::list< Type, Alloc >::rend | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reverse iterator that points to one before the first element in the list. Iteration is done in reverse element order. Definition at line 661 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
reverse_iterator std::list< Type, Alloc >::rend | ( |  | ) | `[inline]`

| Returns a read/write reverse iterator that points to one before the first element in the list. Iteration is done in reverse element order. Definition at line 652 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
void std::list< Type, Alloc >::resize | ( | size_type | new_size | ) | `[inline]`

Resizes the list to the specified number of elements.

Parameters:

  | new_size | Number of elements the list should contain.

This function will resize the list to the specified number of elements. If the number is smaller than the list's current size the list is truncated, otherwise the list is extended and new elements are default-constructed.

Definition at line 706 of file stl_list.h.

template<typename Type, typename Alloc>
void std::list< Type, Alloc >::resize | ( | size_type | new_size,
|  | const value_type & | x
| ) |

Resizes the list to the specified number of elements.

Parameters:

  | new_size | Number of elements the list should contain.
  | x | Data with which new elements should be populated.

This function will resize the list to the specified number of elements. If the number is smaller than the list's current size the list is truncated, otherwise the list is extended and new elements are populated with given data.

Definition at line 105 of file list.tcc.

References std::list< Type, Alloc >::begin(), std::list< Type, Alloc >::end(), std::list< Type, Alloc >::erase(), and std::list< Type, Alloc >::insert().

template<typename Type, typename Alloc = allocator<Type>>
void std::list< Type, Alloc >::reverse | ( |  | ) | `[inline]`

| Reverse the elements in list. Reverse the order of elements in the list in linear time. Definition at line 1075 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
size_type std::list< Type, Alloc >::size | ( |  | ) | const`[inline]`

| Returns the number of elements in the list. Definition at line 675 of file stl_list.h.

template<typename Type, typename Alloc>
template<typename StrictWeakOrdering>
void std::list< Type, Alloc >::sort | ( | StrictWeakOrdering |  | ) |

| Sort the elements according to comparison function. Sorts the elements of this list in NlogN time. Equivalent elements remain in list order. Definition at line 341 of file list.tcc. References std::list< Type, Alloc >::begin(), std::list< Type, Alloc >::empty(), std::list< Type, Alloc >::merge(), std::list< Type, Alloc >::splice(), std::swap(), and std::list< Type, Alloc >::swap().

template<typename Type, typename Alloc>
void std::list< Type, Alloc >::sort | ( |  | ) |

| Sort the elements. Sorts the elements of this list in NlogN time. Equivalent elements remain in list order. Definition at line 237 of file list.tcc. References std::list< Type, Alloc >::begin(), std::list< Type, Alloc >::empty(), std::list< Type, Alloc >::merge(), std::list< Type, Alloc >::splice(), std::swap(), and std::list< Type, Alloc >::swap().

template<typename Type, typename Alloc = allocator<Type>>
void std::list< Type, Alloc >::splice | ( | iterator | position,
|  | list< Type, Alloc > & | ,
|  | iterator | first,
|  | iterator | last
| ) | `[inline]`

Insert range from another list.

Parameters:

  | position | Iterator referencing the element to insert before.
  | x | Source list.
  | first | Iterator referencing the start of range in x.
  | last | Iterator referencing the end of range in x.

Removes elements in the range [first,last) and inserts them before position in constant time.

Undefined if position is in [first,last).

Definition at line 977 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
void std::list< Type, Alloc >::splice | ( | iterator | position,
|  | list< Type, Alloc > & | ,
|  | iterator | __i
| ) | `[inline]`

Insert element from another list.

Parameters:

  | position | Iterator referencing the element to insert before.
  | x | Source list.
  | i | Iterator referencing the element to move.

Removes the element in list x referenced by i and inserts it into the current list before position.

Definition at line 955 of file stl_list.h.

template<typename Type, typename Alloc = allocator<Type>>
void std::list< Type, Alloc >::splice | ( | iterator | position,
|  | list< Type, Alloc > & | x
| ) | `[inline]`

Insert contents of another list.

Parameters:

  | position | Iterator referencing the element to insert before.
  | x | Source list.

The elements of x are inserted in constant time in front of the element referenced by position. x becomes an empty list.

Definition at line 939 of file stl_list.h.

Referenced by std::list< Type, Alloc >::sort().

template<typename Type, typename Alloc = allocator<Type>>
void std::list< Type, Alloc >::swap | ( | list< Type, Alloc > & | x | ) | `[inline]`

Swaps data with another list.

Parameters:

  | x | A list of the same element and allocator types.

This exchanges the elements between two lists in constant time. Note that the global std::swap() function is specialized such that std::swap(l1,l2) will feed to this function.

Definition at line 912 of file stl_list.h.

Referenced by std::list< Type, Alloc >::sort(), and std::swap().

template<typename Type, typename Alloc>
template<typename BinaryPredicate>
void std::list< Type, Alloc >::unique | ( | BinaryPredicate |  | ) |

Remove consecutive elements satisfying a predicate.

Parameters:

  | BinaryPredicate | Binary predicate function or object.

For each consecutive set of elements [first,last) that satisfy predicate(first,i) where i is an iterator in [first,last), remove all but the first one. Remaining elements stay in list order. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 293 of file list.tcc.

References std::list< Type, Alloc >::begin(), and std::list< Type, Alloc >::end().

template<typename Type, typename Alloc>
void std::list< Type, Alloc >::unique | ( |  | ) |

Remove consecutive duplicate elements.

For each consecutive set of elements with the same value, remove all but the first one. Remaining elements stay in list order. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 190 of file list.tcc.

References std::list< Type, Alloc >::begin(), and std::list< Type, Alloc >::end().

The documentation for this class was generated from the following files:

- stl_list.h
- list.tcc